



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python 黑魔法 --- 描述器（descriptor）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python 黑魔法 --- 描述器（descriptor）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 15:00:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>Python 黑魔法---描述器（descriptor）</h4>
<p>Python黑魔法，前面已经介绍了两个魔法，装饰器和迭代器，通常还有个生成器。生成器固然也是一个很优雅的魔法。生成器更像是函数的行为。而连接类行为和函数行为的时候，还有一个描述器魔法，也称之为描述符。</p>
<p>我们不止一次说过，Python的优雅，很大程度在于如何设计成优雅的API。黑魔法则是一大利器。或者说Python的优雅很大程度上是建立在这些魔法巧技基础上。</p>
<h5>何谓描述器</h5>
<p>当定义迭代器的时候，描述是实现迭代协议的对象，即实现<code>__iter__</code>方法的对象。同理，所谓描述器，即实现了描述符协议，即<code>__get__</code>, <code>__set__</code>, 和 <code>__delete__</code>方法的对象。</p>
<p>单看定义，还是比较抽象的。talk is cheap。看代码吧：</p>
<div>
<pre class="prettyprint linenums">class WebFramework(object):<br />
    def __init__(self, name='Flask'):<br />
        self.name = name

    def __get__(self, instance, owner):<br />
        return self.name

    def __set__(self, instance, value):<br />
        self.name = value

class PythonSite(object):

    webframework = WebFramework()

In [1]: PythonSite.webframework<br />
Out[1]: 'Flask'

In [2]: PythonSite.webframework = 'Tornado'

In [3]: PythonSite.webframework<br />
Out[3]: 'Tornado'</pre>
</div>
<p>定义了一个类WebFramework，它实现了描述符协议<code>__get__</code>和<code>__set__</code>，该对象（类也是对象，一切都是对象）即成为了一个描述器。同时实现<code>__get__</code>和<code>__set__</code>的称之为资料描述器（data descriptor）。仅仅实现<code>__get__</code>的则为非描述器。两者的差别是相对于实例的字典的优先级。</p>
<blockquote><p>如果实例字典中有与描述器同名的属性，如果描述器是资料描述器，优先使用资料描述器，如果是非资料描述器，优先使用字典中的属性。</p></blockquote>
<h5>描述器的调用</h5>
<p>对于这类魔法，其调用方法往往不是直接使用的。例如装饰器需要用 @ 符号调用。迭代器通常在迭代过程，或者使用 next 方法调用。描述器则比较简单，对象属性的时候会调用。</p>
<div>
<pre class="prettyprint linenums">In [15]: webframework = WebFramework()

In [16]: webframework.__get__(webframework, WebFramework)<br />
Out[16]: 'Flask'</pre>
</div>
<h5>描述器与对象属性</h5>
<p>OOP的理论中，类的成员变量包括属性和方法。那么在Python里什么是属性？修改上面的PythonSite类如下：</p>
<div>
<pre class="prettyprint linenums">class PythonSite(object):

    webframework = WebFramework()

    version = 0.01

    def __init__(self, site):<br />
        self.site = site</pre>
</div>
<p>这里增加了一个version的类属性，以及一个实例属性site。分别查看一下类和实例对象的属性：</p>
<div>
<pre class="prettyprint linenums">In [1]: pysite = PythonSite('ghost')

In [2]: vars(PythonSite).items()<br />
Out[2]:<br />
[('__module__', '__main__'),<br />
 ('version', 0.01),<br />
 ('__dict__', &lt;attribute '__dict__' of 'PythonSite' objects&gt;),<br />
 ('webframework', &lt;__main__.WebFramework at 0x10d55be90&gt;),<br />
 ('__weakref__', &lt;attribute '__weakref__' of 'PythonSite' objects&gt;),<br />
 ('__doc__', None),<br />
 ('__init__', &lt;function __main__.__init__&gt;)]

In [3]: vars(pysite)<br />
Out[3]: {'site': 'ghost'}<br />
In [4]: PythonSite.__dict__<br />
Out[4]:<br />
&lt;dictproxy {'__dict__': &lt;attribute '__dict__' of 'PythonSite' objects&gt;,<br />
 '__doc__': None,<br />
 '__init__': &lt;function __main__.__init__&gt;,<br />
 '__module__': '__main__',<br />
 '__weakref__': &lt;attribute '__weakref__' of 'PythonSite' objects&gt;,<br />
 'version': 0.01,<br />
 'webframework': &lt;__main__.WebFramework at 0x10d55be90&gt;}&gt;</pre>
</div>
<p>vars方法用于查看对象的属性，等价于对象的<code>__dict__</code>内容。从上面的显示结果，可以看到类PythonSite和实例pysite的属性差别在于前者有 webframework，version两个属性，以及 <code>__init__</code>方法，后者仅有一个site属性。</p>
<h6>类与实例的属性</h6>
<p>类属性可以使用对象和类访问，多个实例对象共享一个类变量。但是只有类才能修改。</p>
<div>
<pre class="prettyprint linenums">In [6]: pysite1 = PythonSite('ghost')

In [7]: pysite2 = PythonSite('admin')

In [8]: PythonSite.version<br />
Out[8]: 0.01

In [9]: pysite1.version<br />
Out[9]: 0.01

In [10]: pysite2.version<br />
Out[10]: 0.01

In [11]: pysite1.version is pysite2.version<br />
Out[11]: True

In [12]: pysite1.version = 'pysite1'

In [13]: vars(pysite1)<br />
Out[13]: {'site': 'ghost', 'version': 'pysite1'}

In [14]: vars(pysite2)<br />
Out[14]: {'site': 'admin'}

In [15]: PythonSite.version = 0.02

In [16]: pysite1.version<br />
Out[16]: 'pysite1'

In [17]: pysite2.version<br />
Out[17]: 0.02</pre>
</div>
<p>正如上面的代码显示，两个实例对象都可以访问version类属性，并且是同一个类属性。当pysite1修改了version，实际上是给自己添加了一个version属性。类属性并没有被改变。当PythonSite改变了version属性的时候，pysite2的该属性也对应被改变。</p>
<h5>属性访问的原理与描述器</h5>
<p>知道了属性访问的结果。这个结果都是基于<code>Python</code>的描述器实现的。通常，类或者实例通过<code>.</code>操作符访问属性。例如<code>pysite1.site</code>和<code>pysite1.version</code>的访问。先访问对象的<code>__dict__</code>，如果没有再访问类（或父类，元类除外）的<code>__dict__</code>。如果最后这个<code>__dict__</code>的对象是一个描述器，则会调用描述器的<code>__get__</code>方法。</p>
<div>
<pre class="prettyprint linenums">In [21]: pysite1.site<br />
Out[21]: 'ghost'

In [22]: pysite1.__dict__['site']<br />
Out[22]: 'ghost'

In [23]: pysite2.version<br />
Out[23]: 0.02

In [24]: pysite2.__dict__['version']<br />
---------------------------------------------------------------------------<br />
KeyError                                  Traceback (most recent call last)<br />
&lt;ipython-input-24-73ef6aeba259&gt; in &lt;module&gt;()<br />
----&gt; 1 pysite2.__dict__['version']

KeyError: 'version'

In [25]: type(pysite2).__dict__['version']<br />
Out[25]: 0.02

In [32]: type(pysite1).__dict__['webframework']<br />
Out[32]: &lt;__main__.WebFramework at 0x103426e90&gt;

In [38]: type(pysite1).__dict__['webframework'].__get__(None, PythonSite)<br />
Out[38]: 'Flask'</pre>
</div>
<h5>实例方法，类方法，静态方法与描述器</h5>
<p>调用描述器的时候，实际上会调用<code>object.__getattribute__()</code>。这取决于调用描述其器的是对象还是类，如果是对象<code>obj.x</code>，则会调用<code>type(obj).__dict__['x'].__get__(obj, type(obj))</code>。如果是类，class.x， 则会调用<code>type(class).__dict__['x'].__get__(None, type(class)</code>。</p>
<p>这样说还是比较抽象，下面来分析Python的方法，静态方法和类方法。把PythonSite重构一下：</p>
<div>
<pre class="prettyprint linenums">class PythonSite(object):<br />
    webframework = WebFramework()

    version = 0.01

    def __init__(self, site):<br />
        self.site = site

    def get_site(self):<br />
        return self.site

    @classmethod<br />
    def get_version(cls):<br />
        return cls.version

    @staticmethod<br />
    def find_version():<br />
        return PythonSite.version</pre>
</div>
<h6>类方法，@classmethod装饰器</h6>
<p>先看类方法，类方法使用@classmethod装饰器定义。经过该装饰器的方法是一个描述器。类和实例都可以调用类方法：</p>
<div>
<pre class="prettyprint linenums">In [1]: ps = PythonSite('ghost')

In [2]: ps.get_version<br />
Out[2]: &lt;bound method type.get_version of &lt;class '__main__.PythonSite'&gt;&gt;

In [3]: ps.get_version()<br />
Out[3]: 0.01

In [4]: PythonSite.get_version<br />
Out[4]: &lt;bound method type.get_version of &lt;class '__main__.PythonSite'&gt;&gt;

In [5]: PythonSite.get_version()<br />
Out[5]: 0.01</pre>
</div>
<p>get_version 是一个bound方法。下面再看下<code>ps.get_version</code>这个调用，会先查找它·的<code>__dict__</code>是否有<code>get_version</code>这个属性，如果没有，则查找其类。</p>
<div>
<pre class="prettyprint linenums">In [6]: vars(ps)<br />
Out[6]: {'site': 'ghost'}

In [7]: type(ps).__dict__['get_version']<br />
Out[7]: &lt;classmethod at 0x108952e18&gt;

In [8]: type(ps).__dict__['get_version'].__get__(ps, type(ps))<br />
Out[8]: &lt;bound method type.get_version of &lt;class '__main__.PythonSite'&gt;&gt;

In [9]: type(ps).__dict__['get_version'].__get__(ps, type(ps)) == ps.get_version<br />
Out[9]: True</pre>
</div>
<p>并且vars(ps)中，<code>__dict__</code>并没有<code>get_version</code>这个属性，依据描述器协议，将会调用<code>type(ps).__dict__['get_version']</code>描述器的<code>__get__</code>方法，因为ps是实例，因此<code>object.__getattribute__()</code>会这样调用<code>__get__(obj, type(obj))</code>。</p>
<p>现在再看类方法的调用:</p>
<div>
<pre class="prettyprint linenums">In [10]: PythonSite.__dict__['get_version']<br />
Out[10]: &lt;classmethod at 0x108952e18&gt;

In [11]: PythonSite.__dict__['get_version'].__get__(None, PythonSite)<br />
Out[11]: &lt;bound method type.get_version of &lt;class '__main__.PythonSite'&gt;&gt;

In [12]: PythonSite.__dict__['get_version'].__get__(None, PythonSite) == PythonSite.get_version<br />
Out[12]: True</pre>
</div>
<p>因为这次调用get_version的是一个类对象，而不是实例对象，因此<code>object.__getattribute__()</code>会这样调用<code>__get__(None, Class)</code>。</p>
<h6>静态方法，@staticmethod</h6>
<p>实例和类也可以调用静态方法：</p>
<div>
<pre class="prettyprint linenums">In [13]: ps.find_version<br />
Out[13]: &lt;function __main__.find_version&gt;

In [14]: ps.find_version()<br />
Out[14]: 0.01

In [15]: vars(ps)<br />
Out[15]: {'site': 'ghost'}

In [16]: type(ps).__dict__['find_version']<br />
Out[16]: &lt;staticmethod at 0x108952d70&gt;

In [17]: type(ps).__dict__['find_version'].__get__(ps, type(ps))<br />
Out[17]: &lt;function __main__.find_version&gt;

In [18]: type(ps).__dict__['find_version'].__get__(ps, type(ps)) == ps.find_version<br />
Out[18]: True

In [19]: PythonSite.find_version()<br />
Out[19]: 0.01

In [20]: PythonSite.find_version<br />
Out[20]: &lt;function __main__.find_version&gt;

In [21]: type(ps).__dict__['find_version'].__get__(None, type(ps))<br />
Out[21]: &lt;function __main__.find_version&gt;

In [22]: type(ps).__dict__['find_version'].__get__(None, type(ps)) == PythonSite.find_version<br />
Out[22]: True</pre>
</div>
<p>和类方法差别不大，他们的主要差别是在类方法内部的时候，类方法可以有<code>cls</code>的类引用，静态访问则没有，如果静态方法想使用类变量，只能硬编码类名。</p>
<h6>实例方法</h6>
<p>实例方法最为复杂，是专门属于实例的，使用类调用的时候，会是一个<code>unbound</code>方法。</p>
<div>
<pre class="prettyprint linenums">In [2]: ps.get_site<br />
Out[2]: &lt;bound method PythonSite.get_site of &lt;__main__.PythonSite object at 0x1054ae2d0&gt;&gt;

In [3]: ps.get_site()<br />
Out[3]: 'ghost'

In [4]: type(ps).__dict__['get_site']<br />
Out[4]: &lt;function __main__.get_site&gt;

In [5]: type(ps).__dict__['get_site'].__get__(ps, type(ps))<br />
Out[5]: &lt;bound method PythonSite.get_site of &lt;__main__.PythonSite object at 0x1054ae2d0&gt;&gt;

In [6]: type(ps).__dict__['get_site'].__get__(ps, type(ps)) == ps.get_site<br />
Out[6]: True</pre>
</div>
<p>一切工作正常，实例方法也是类的一个属性，但是对于类，描述器使其变成了<code>unbound</code>方法：</p>
<div>
<pre class="prettyprint linenums">In [7]: PythonSite.get_site<br />
Out[7]: &lt;unbound method PythonSite.get_site&gt;

In [8]: PythonSite.get_site()<br />
---------------------------------------------------------------------------<br />
TypeError                                 Traceback (most recent call last)<br />
&lt;ipython-input-8-99c7d7607137&gt; in &lt;module&gt;()<br />
----&gt; 1 PythonSite.get_site()

TypeError: unbound method get_site() must be called with PythonSite instance as first argument (got nothing instead)

In [9]: PythonSite.get_site(ps)<br />
Out[9]: 'ghost'

In [10]: PythonSite.__dict__['get_site']<br />
Out[10]: &lt;function __main__.get_site&gt;

In [11]: PythonSite.__dict__['get_site'].__get__(None, PythonSite)<br />
Out[11]: &lt;unbound method PythonSite.get_site&gt;

In [12]: PythonSite.__dict__['get_site'].__get__(None, PythonSite) == PythonSite.get_site<br />
Out[12]: True

In [14]: PythonSite.__dict__['get_site'].__get__(ps, PythonSite)<br />
Out[14]: &lt;bound method PythonSite.get_site of &lt;__main__.PythonSite object at 0x1054ae2d0&gt;&gt;

In [15]: PythonSite.__dict__['get_site'].__get__(ps, PythonSite)()<br />
Out[15]: 'ghost'</pre>
</div>
<p>由此可见，类不能直接调用实例方法，除非在描述器手动绑定一个类实例。因为使用类对象调用描述器的时候，<code>__get__</code>的第一个参数是None，想要成功调用，需要把这个参数替换为实例<code>ps</code>，这个过程就是对方法的bound过程。</p>
<h5>描述器的应用</h5>
<p>描述器的作用主要在方法和属性的定义上。既然我们可以重新描述类的属性，那么这个魔法就可以改变类的一些行为。最简单的应用则是可以配合装饰器，写一个类属性的缓存。Flask的作者写了一个werkzeug网络工具库，里面就使用描述器的特性，实现了一个缓存器。</p>
<div>
<pre class="prettyprint linenums">class _Missing(object):<br />
    def __repr__(self):<br />
        return 'no value'

    def __reduce__(self):<br />
        return '_missing'

_missing = _Missing()

class cached_property(object):<br />
    def __init__(self, func, name=None, doc=None):<br />
        self.__name__ = name or func.__name__<br />
        self.__module__ = func.__module__<br />
        self.__doc__ = doc or func.__doc__<br />
        self.func = func

    def __get__(self, obj, type=None):<br />
        if obj is None:<br />
            return self<br />
        value = obj.__dict__.get(self.__name__, _missing)<br />
        if value is _missing:<br />
            value = self.func(obj)<br />
            obj.__dict__[self.__name__] = value<br />
        return value

class Foo(object):<br />
    @cached_property<br />
    def foo(self):<br />
        print 'first calculate'<br />
        result = 'this is result'<br />
        return result

f = Foo()

print f.foo   # first calculate this is result<br />
print f.foo   # this is result</pre>
</div>
<p>运行结果可见，<code>first calculate</code>只在第一次调用时候被计算之后就把结果缓存起来了。这样的好处是在网络编程中，对HTTP协议的解析，通常会把HTTP的header解析成python的一个字典，而在视图函数的时候，可能不知一次的访问这个header，因此把这个header使用描述器缓存起来，可以减少多余的解析。</p>
<p>描述器在python的应用十分广泛，通常是配合装饰器一起使用。强大的魔法来自强大的责任。描述器还可以用来实现ORM中对sql语句的&quot;预编译&quot;。恰当的使用描述器，可以让自己的Python代码更优雅。</p>
<p>文／人世间（简书作者）<br />
  <br />原文链接：http://www.jianshu.com/p/250f0d305c35</p>
<p>著作权归作者所有，转载请联系作者获得授权，并标注“简书作者”。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy40ddq.html">【C&num; 进阶】事件！直接上事件！</a>
		</li>
						<li><a href="https://www.batexi.com/a/390j64j8.html">js实现css、addClass、removeClass和toggleClass</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy54rx9.html">update the UI property cross thread</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e3dgkq.html">Node Express 4&period;0 安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kz5568.html">scp使用加密算法报错unknown cipher type</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvyw6xq.html">关于卡尔曼滤波&lpar;Kalman Filter&rpar;的很好讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rjzgm8.html">解决Apache CXF 不支持传递java&period;sql&period;Timestamp和java&period;util&period;HashMap类型问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oox5j9.html">通过CoreImage生成二维码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjm0l49.html">HDU 3544 &lpar;不平等博弈&rpar; Alice&amp;&num;39&semi;s Game</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o7zwj9.html">koa redis 链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/96odlo49.html">MAC机常用快捷键整理表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm45g19.html">Highcharts 基本曲线图</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zp5k59.html">hibernate 和 jdbc 优缺点对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj32x1q.html">201521123034《Java程序设计》第十三周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/950zozz8.html">C&plus;&plus;移动构造函数以及move语句简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kprvd69.html">lintcode 132 模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzwyj48.html">centos7下kubernetes（18。kubernetes-健康检查）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rmrmj9.html">OpenCL 矩阵乘法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g7xkzq.html">leetcode128</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw3w609.html">【Maven】eclipse中使用Maven、生命周期</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/39rrlo79.html">hdu4737 A Bit Fun</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyjjw2q.html">windows Apache&plus;cgi的配置方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql3rz6q.html">linux 常用的酷炫命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxm7yv9.html">js监听rem实现响应式</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kgx4r9.html">&lbrack;轉&rsqb;Android Libraries 介紹 - Butter knife</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9po0jyq.html">&lbrack;Spring MVC&rsqb; - Spring MVC环境搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kgy259.html">FFmpeg&period;exe使用随笔</a>
			</li>
						<li><a href="https://www.batexi.com/a/r932elrq.html">HackerRank &amp;quot&semi;Prim&amp;&num;39&semi;s &lpar;MST&rpar; &colon; Special Subtree&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2lopv9.html">change-resource-tags&period;sh</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd4m0xq.html">ElasticSearch安装及部署</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
